<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Async JS</title>
</head>

<body>
  <main>
    <h1>counter</h1>
    <label>
      count down to:
      <input id="input" type="number" min="1" value="30" />
    </label>
    <button id="start">
      start!
    </button>
    <h2 id="counter"></h2>
  </main>

  <script>
    let intervalId = null

    function start(payload) {
      let count = parseInt(document.querySelector('#input').value)
      const update = value => document.querySelector('#counter').innerHTML = value

      clearInterval(intervalId)
      update(count)

      intervalId = setInterval(() => {
        update(--count)

        if (count === 0) {
          clearInterval(intervalId)
          update('Done!')
        }
      }, 1000)
    }

    document.querySelector('#start').addEventListener('click', start)
  </script>
</body>

</html>
